---
displayed_sidebar: servicesSidebar
---

import ParameterTypes from "@site/src/components/ParameterTypes"

# RegionService

Provides layer to manipulate regions.

## constructor

### Parameters

<ParameterTypes parameters={[
  {
    "name": "__namedParameters",
    "type": "`InjectedDependencies`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

___

## Properties

<ParameterTypes parameters={[
  {
    "name": "__configModule__",
    "type": "`Record<string, unknown>`",
    "description": "",
    "optional": true,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "__container__",
    "type": "`any`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "__moduleDeclaration__",
    "type": "`Record<string, unknown>`",
    "description": "",
    "optional": true,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "countryRepository_",
    "type": "Repository&#60;[Country](../../entities/classes/entities.Country.mdx)&#62;",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "currencyRepository_",
    "type": "Repository&#60;[Currency](../../entities/classes/entities.Currency.mdx)&#62;",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "eventBus_",
    "type": "[EventBusService](services.EventBusService.mdx)",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "featureFlagRouter_",
    "type": "`FlagRouter`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "fulfillmentProviderRepository_",
    "type": "Repository&#60;[FulfillmentProvider](../../entities/classes/entities.FulfillmentProvider.mdx)&#62;",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "fulfillmentProviderService_",
    "type": "[FulfillmentProviderService](services.FulfillmentProviderService.mdx)",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "manager_",
    "type": "`EntityManager`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "paymentProviderRepository_",
    "type": "Repository&#60;[PaymentProvider](../../entities/classes/entities.PaymentProvider.mdx)&#62;",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "paymentProviderService_",
    "type": "[PaymentProviderService](services.PaymentProviderService.mdx)",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "regionRepository_",
    "type": "Repository&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "storeService_",
    "type": "[StoreService](services.StoreService.mdx)",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "taxProviderRepository_",
    "type": "Repository&#60;[TaxProvider](../../entities/classes/entities.TaxProvider.mdx)&#62;",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "transactionManager_",
    "type": "`undefined` \\| `EntityManager`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "Events",
    "type": "`object`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "Events.CREATED",
    "type": "`string`",
    "description": "",
    "optional": false,
    "defaultValue": "\"region.created\"",
    "expandable": false,
    "children": []
  },
  {
    "name": "Events.DELETED",
    "type": "`string`",
    "description": "",
    "optional": false,
    "defaultValue": "\"region.deleted\"",
    "expandable": false,
    "children": []
  },
  {
    "name": "Events.UPDATED",
    "type": "`string`",
    "description": "",
    "optional": false,
    "defaultValue": "\"region.updated\"",
    "expandable": false,
    "children": []
  }
]} />

___

## Accessors

### activeManager\_

#### Returns

<ParameterTypes parameters={[
  {
    "name": "EntityManager",
    "type": "`EntityManager`",
    "optional": false,
    "defaultValue": "",
    "description": "",
    "expandable": false,
    "children": []
  }
]} />

___

## Methods

### addCountry

Adds a country to the region.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "regionId",
    "type": "`string`",
    "description": "the region to add a country to",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "code",
    "type": "`string`",
    "description": "a 2 digit alphanumeric ISO country code.",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the updated Region",
    "expandable": false,
    "children": []
  }
]} />

___

### addFulfillmentProvider

Adds a fulfillment provider that is available in the region. Fails if the
provider doesn't exist.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "regionId",
    "type": "`string`",
    "description": "the region to add the provider to",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "providerId",
    "type": "`string`",
    "description": "the provider to add to the region",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the updated Region",
    "expandable": false,
    "children": []
  }
]} />

___

### addPaymentProvider

Adds a payment provider that is available in the region. Fails if the
provider doesn't exist.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "regionId",
    "type": "`string`",
    "description": "the region to add the provider to",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "providerId",
    "type": "`string`",
    "description": "the provider to add to the region",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the updated Region",
    "expandable": false,
    "children": []
  }
]} />

___

### atomicPhase\_

Wraps some work within a transactional block. If the service already has
a transaction manager attached this will be reused, otherwise a new
transaction manager is created.

#### Type Parameters

<ParameterTypes parameters={[
  {
    "name": "TResult",
    "type": "`object`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "TError",
    "type": "`object`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "work",
    "type": "(`transactionManager`: `EntityManager`) => Promise&#60;TResult&#62;",
    "description": "the transactional work to be done",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "isolationOrErrorHandler",
    "type": "`IsolationLevel` \\| (`error`: `TError`) => Promise&#60;void \\| TResult&#62;",
    "description": "the isolation level to be used for the work.",
    "optional": true,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "maybeErrorHandlerOrDontFail",
    "type": "(`error`: `TError`) => Promise&#60;void \\| TResult&#62;",
    "description": "Potential error handler",
    "optional": true,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;TResult&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the result of the transactional work",
    "expandable": false,
    "children": []
  }
]} />

___

### create

Creates a region.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "data",
    "type": "`CreateRegionInput`",
    "description": "the unvalidated region",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the newly created region",
    "expandable": false,
    "children": []
  }
]} />

___

### delete

Deletes a region.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "regionId",
    "type": "`string`",
    "description": "the region to delete",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;void&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the result of the delete operation",
    "expandable": false,
    "children": []
  }
]} />

___

### list

Lists all regions based on a query

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "selector",
    "type": "[Selector](../../medusa/types/medusa.Selector.mdx)&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "description": "query object for find",
    "optional": false,
    "defaultValue": "{}",
    "expandable": false,
    "children": []
  },
  {
    "name": "config",
    "type": "[FindConfig](../../medusa/interfaces/medusa.FindConfig.mdx)&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "description": "configuration settings",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[Region](../../entities/classes/entities.Region.mdx)[]&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "result of the find operation",
    "expandable": false,
    "children": []
  }
]} />

___

### listAndCount

Lists all regions based on a query and returns them along with count

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "selector",
    "type": "[Selector](../../medusa/types/medusa.Selector.mdx)&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "description": "query object for find",
    "optional": false,
    "defaultValue": "{}",
    "expandable": false,
    "children": []
  },
  {
    "name": "config",
    "type": "[FindConfig](../../medusa/interfaces/medusa.FindConfig.mdx)&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "description": "configuration settings",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[[Region](../../entities/classes/entities.Region.mdx)[], number]&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "result of the find operation",
    "expandable": false,
    "children": []
  }
]} />

___

### removeCountry

Removes a country from a Region.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "regionId",
    "type": "`string`",
    "description": "the region to remove from",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "code",
    "type": "`string`",
    "description": "a 2 digit alphanumeric ISO country code to remove",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the updated Region",
    "expandable": false,
    "children": []
  }
]} />

___

### removeFulfillmentProvider

Removes a fulfillment provider from a region. Is idempotent.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "regionId",
    "type": "`string`",
    "description": "the region to remove the provider from",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "providerId",
    "type": "`string`",
    "description": "the provider to remove from the region",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the updated Region",
    "expandable": false,
    "children": []
  }
]} />

___

### removePaymentProvider

Removes a payment provider from a region. Is idempotent.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "regionId",
    "type": "`string`",
    "description": "the region to remove the provider from",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "providerId",
    "type": "`string`",
    "description": "the provider to remove from the region",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the updated Region",
    "expandable": false,
    "children": []
  }
]} />

___

### retrieve

Retrieves a region by its id.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "regionId",
    "type": "`string`",
    "description": "the id of the region to retrieve",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "config",
    "type": "[FindConfig](../../medusa/interfaces/medusa.FindConfig.mdx)&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "description": "configuration settings",
    "optional": false,
    "defaultValue": "{}",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the region",
    "expandable": false,
    "children": []
  }
]} />

___

### retrieveByCountryCode

Retrieve a region by country code.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "code",
    "type": "`string`",
    "description": "a 2 digit alphanumeric ISO country code",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "config",
    "type": "[FindConfig](../../medusa/interfaces/medusa.FindConfig.mdx)&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "description": "region find config",
    "optional": false,
    "defaultValue": "{}",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "a Region with country code",
    "expandable": false,
    "children": []
  }
]} />

___

### retrieveByName

Retrieves a region by name.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "name",
    "type": "`string`",
    "description": "the name of the region to retrieve",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "region with the matching name",
    "expandable": false,
    "children": []
  }
]} />

___

### shouldRetryTransaction\_

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "err",
    "type": "`Record<string, unknown>` \\| `object`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "boolean",
    "type": "`boolean`",
    "optional": true,
    "defaultValue": "",
    "description": "",
    "expandable": false,
    "children": []
  }
]} />

___

### update

Updates a region

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "regionId",
    "type": "`string`",
    "description": "the region to update",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "update",
    "type": "`UpdateRegionInput`",
    "description": "the data to update the region with",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the result of the update operation",
    "expandable": false,
    "children": []
  }
]} />

___

### validateCountry

Validates a country code. Will normalize the code before checking for
existence.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "code",
    "type": "`string`",
    "description": "a 2 digit alphanumeric ISO country code",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "regionId",
    "type": "`string`",
    "description": "the id of the current region to check against",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[Country](../../entities/classes/entities.Country.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the validated Country",
    "expandable": false,
    "children": []
  }
]} />

___

### validateCurrency

Validates a currency code. Will throw if the currency code doesn't exist.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "currencyCode",
    "type": "`string`",
    "description": "an ISO currency code",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;void&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "void",
    "expandable": false,
    "children": []
  }
]} />

#### Throws

if the provided currency code is invalid

___

### validateFields

Validates fields for creation and updates. If the region already exists
the id can be passed to check that country updates are allowed.

#### Type Parameters

<ParameterTypes parameters={[
  {
    "name": "T",
    "type": "`UpdateRegionInput` \\| `CreateRegionInput`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "regionData",
    "type": "Omit&#60;T, \"metadata\" \\| \"currency_code\"&#62;",
    "description": "the region data to validate",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "id",
    "type": "`T` extends `UpdateRegionInput` ? `string` : `undefined`",
    "description": "optional id of the region to check against",
    "optional": true,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;DeepPartial&#60;[Region](../../entities/classes/entities.Region.mdx)&#62;&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the validated region data",
    "expandable": false,
    "children": []
  }
]} />

___

### validateTaxRate

Validates a tax rate. Will throw if the tax rate is not between 0 and 1.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "taxRate",
    "type": "`number`",
    "description": "a number representing the tax rate of the region",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "void",
    "type": "`void`",
    "optional": true,
    "defaultValue": "",
    "description": "void",
    "expandable": false,
    "children": []
  }
]} />

#### Throws

if the tax rate isn't number between 0-100

___

### withTransaction

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "transactionManager",
    "type": "`EntityManager`",
    "description": "",
    "optional": true,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "RegionService",
    "type": "`object`",
    "description": "Provides layer to manipulate regions.",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />
